package nats

import (
	"Panel_development/global"
	"Panel_development/simple_zap"
	"context"
	"fmt"
	"github.com/nats-io/nats.go"
)

var Nats *nats.Conn

func SetupNats() {
	var err error
	fmt.Println(global.NatsSetting.NatsServerUrl)
	Nats, err = nats.Connect(global.NatsSetting.NatsServerUrl)
	if err != nil {
		simple_zap.WithCtx(context.Background()).Sugar().Warn(err, "nats 连接失败")
		panic(err)
	}
	simple_zap.WithCtx(context.Background()).Sugar().Info(err, "nats 连接成功")
}
